var dashboardResourceDecorator = function($delegate, userService) {
    var sections = ["content", "media", "settings", "developer"];
    
    $delegate.getDashboard = (function(section) {
        
        var cached_function = $delegate.getDashboard;
        var flowdashboard = {"id":0,
                "active":true,
                "label":"Your workspace",
                "alias":"YourWorkspace",
                "properties":[
                    {
                        "showOnce":false,
                        "addPanel":false,
                        "serverSide":false,
                        "path":"/app_plugins/deploy/views/flow.html",
                        "caption":null
                    }
                 ]
                 };
                 
        return function(section) {
            var promise = cached_function.apply(this, arguments);
            
            if(sections.indexOf(section) >= 0){
                var promise_then = promise.then;
                promise.then = function(callback){
                    promise_then(function(response){
                        userService.isAuthenticated().then(function(){
                            response.splice(0, 0, flowdashboard); 
                            callback(response);      
                        });
                    });
                };
            }
        
            return promise;
        };
    }());

    return $delegate;
};

angular.module("umbraco").config(["$provide", function ($provide) {
    $provide.decorator("dashboardResource",  dashboardResourceDecorator);
}]);